<script setup lang="ts">
import { onMounted, ref } from 'vue'
import type { VForm } from 'vuetify/components'
import { useRoute } from 'vue-router'
import router from '@/router'
import { useBranchStore } from '@/stores/branch'
import { useUserStore } from '@/stores/user'
import { useAuthStore } from '@/stores/auth'
import { usePermissionStore } from '@/stores/permission'

const route = useRoute()
const headers = [
  {
    title: 'Id',
    key: 'id'
  },
  {
    title: 'Name',
    key: 'name'
  },
  {
    title: 'Tel',
    key: 'tel'
  },
  {
    title: 'Address',
    key: 'Address'
  },
  {
    title: 'Manager',
    key: 'manager'
  },
  { title: 'Actions', key: 'actions', sortable: false }
]

const authStore = useAuthStore()
const branchStore = useBranchStore()
const permissionStore = usePermissionStore()
const usersStore = useUserStore()
const search = ref('')

const refform = ref<VForm | null>(null)
const loading = ref(false)

async function save() {
  const { valid } = await refform.value!.validate()
  if (!valid) return
  branchStore.save()
}

onMounted(async () => {
  if (!permissionStore.isEmp()) {
    permissionStore.pushMember()
  } else if (authStore.getCurrentUser()?.role !== 'Owner') {
    permissionStore.pushEmp()
  }
  await branchStore.getBranchs()
  await usersStore.getManager()
})
</script>

<template>
  <v-toolbar flat style="background-color: #212121; color: white">
    <v-toolbar-title>Branch</v-toolbar-title>
    <v-spacer></v-spacer>

    <v-text-field
      v-model="search"
      prepend-inner-icon="mdi-magnify"
      density="compact"
      label="Search"
      single-line
      flat
      hide-details
      variant="solo-filled"
      style="width: 1px; margin-left: 1000px"
    ></v-text-field>

    <v-col>
      <v-dialog v-model="branchStore.dialog" persistent width="600">
        <template v-slot:activator="{ props }">
          <v-btn
            v-bind="props"
            prepend-icon="mdi-plus"
            style="background-color: #c7a17a; color: white"
          >
            New Branch
          </v-btn>
        </template>
        <v-card>
          <v-card-title>
            <span class="text-h5">Branch</span>
          </v-card-title>
          <v-card-text>
            <v-form ref="refform" v-model="branchStore.form" @submit.prevent="branchStore.onSubmit">
              <v-container>
                <v-row>
                  <v-col cols="12" sm="12" md="12">
                    <v-text-field
                      v-model="branchStore.editedBranch.name"
                      :readonly="loading"
                      :rules="[(v) => !!v || 'Field is required']"
                      class="mb-2"
                      clearable
                      label="Name"
                    ></v-text-field>
                  </v-col>

                  <v-col cols="12" sm="12" md="6">
                    <v-text-field
                      v-model="branchStore.editedBranch.tel"
                      :readonly="loading"
                      :rules="[
                        (v) => !!v || 'Field is required',
                        (v) => /^[0-9()+\-]{10}$/.test(v) || 'Invalid telephone number'
                      ]"
                      clearable
                      label="Tel"
                      placeholder="Enter Telephone"
                    ></v-text-field>
                  </v-col>

                  <v-col cols="12" sm="6" md="6">
                    <v-combobox
                      v-model="branchStore.editedBranch.manager"
                      label="Manager"
                      :rules="[(v) => !!v || 'Please select a manager']"
                      :items="usersStore.managers"
                      item-title="fullName"
                      :return-object="true"
                    ></v-combobox>
                  </v-col>

                  <v-col cols="12" sm="12" md="12">
                    <v-textarea
                      v-model="branchStore.editedBranch.Address"
                      :readonly="loading"
                      :rules="[(v) => !!v || 'Field is required']"
                      class="mb-2"
                      clearable
                      label="Address"
                    ></v-textarea>
                  </v-col>
                </v-row>
              </v-container>
            </v-form>
            <small>*indicates required field</small>
          </v-card-text>
          <v-card-actions>
            <v-spacer></v-spacer>
            <v-btn color="primary" variant="text" @click="branchStore.closeDialog()"> Close </v-btn>
            <v-btn color="primary" variant="text" @click="save()"> Save </v-btn>
          </v-card-actions>
        </v-card>
      </v-dialog>
    </v-col>
    <!--Delete Dialog-->
    <v-dialog v-model="branchStore.dialogDelete" width="500px">
      <v-card>
        <br />
        <v-img style="margin-left: 230px" :width="40" src="\src\assets\Login\icon.png"></v-img>
        <v-spacer></v-spacer>
        <v-card-title align="center" class="text-h5">Are you sure?</v-card-title>
        <v-card-title align="center" class="text-h10">
          This action cannot be undone.<br />
          All values associated with this field will be lost.
        </v-card-title>
        <v-spacer></v-spacer>
        <div align="center">
          <div style="margin: 0 auto; max-width: 400px">
            <v-btn
              block
              style="background-color: #e11d48"
              color="white"
              variant="text"
              @click="branchStore.deleteBranch()"
            >
              Delete field
            </v-btn>
          </div>
        </div>
        <div align="center">
          <div
            style="
              margin: 0 auto;
              max-width: 400px;
              border: 1px solid #dfe1e6;
              border-radius: 5px;
              margin-top: 10px;
            "
          >
            <v-btn block color="primary" variant="text" @click="branchStore.closeDelete()">
              Cancel
            </v-btn>
          </div>
        </div>
        <v-spacer></v-spacer>
        <br />
      </v-card>
    </v-dialog>
  </v-toolbar>
  <div>
    <v-data-table v-model:search="search" :headers="headers" :items="branchStore.branchs">
      <template v-slot:top> </template>
      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" class="me-2" @click="branchStore.editBranch(item)">
          mdi-pencil
        </v-icon>
        <v-icon size="small" @click="branchStore.deleteBranchConfirm(item)"> mdi-delete </v-icon>
      </template>
    </v-data-table>
  </div>
</template>

<style>
tbody tr:nth-of-type(even) {
  background-color: #dddcde;
}

tbody tr:nth-of-type(odd) {
  background-color: #f5f4f7;
}

thead {
  background-color: #403c3c;
  color: rgb(0, 0, 0);
  font-weight: bold;
  color: white;
}

.theme--light.v-data-table thead tr th {
  color: white;
}
</style>
